function IsPek = IsPekerisWaterLayer(Layer)
%Checks to see whether the specified layer is a water column layer suitable for a Pekeris environment

IsPek =  ...
   	(min(Layer.Cp) == max(Layer.Cp)) & ...
      (min(Layer.Rho) == max(Layer.Rho)) & ...
      isempty(find(Layer.Cs ~= 0)) & ...
      isempty(find(Layer.Ap ~= 0)) & ...      
      isempty(find(Layer.As ~= 0)) & ... 
      ~Layer.IsHalfSpace;